/* 
 * File:   TCS3771.h
 * Author: NickMechatronics
 *
 * Created on April 29, 2014, 4:47 PM
 */

#ifndef TCS3771_H
#define	TCS3771_H

#include <plib.h>

// TCS3771 Setup code

#define TCS_ADDRESS_WRITE 0x52//(0x29<<1)|0
#define TCS_ADDRESS_READ  0x53//(0x29<<1)|1

// Registers:
#define TCS_ENABLE 	0x00  //R/W Enables states and interrupts 0x00
#define TCS_ATIME 	0x01  //R/W RGBC ADC time 0xFF
#define TCS_PTIME 	0x02  //R/W Proximity ADC time 0xFF
#define TCS_WTIME 	0x03  //R/W Wait time 0xFF
#define TCS_AILTL 	0x04  //R/W RGBC interrupt low threshold low byte 0x00
#define TCS_AILTH 	0x05  //R/W RGBC interrupt low threshold high byte 0x00
#define TCS_AIHTL 	0x06  //R/W RGBC interrupt high threshold low byte 0x00
#define TCS_AIHTH 	0x07  //R/W RGBC interrupt high threshold high byte 0x00
#define TCS_PILTL 	0x08  //R/W Proximity interrupt low threshold low byte 0x00
#define TCS_PILTH 	0x09  //R/W Proximity interrupt low threshold high byte 0x00
#define TCS_PIHTL 	0x0A  //R/W Proximity interrupt high threshold low byte 0x00
#define TCS_PIHTH 	0x0B  //R/W Proximity interrupt high threshold high byte 0x00
#define TCS_PERS 	0x0C  //R/W Interrupt persistence filters 0x00
#define TCS_CONFIG 	0x0D  //R/W Configuration 0x00
#define TCS_PPCOUNT     0x0E  //R/W Proximity pulse count 0x00
#define TCS_CONTROL     0x0F  //R/W Gain control register 0x00
#define TCS_ID 		0x12  //R Device ID ID of TC3771 is 0x19 (decimal 25)
#define TCS_STATUS 	0x13  //R Device status 0x00
#define TCS_CDATA 	0x14  //R Clear ADC low data register 0x00
#define TCS_CDATAH 	0x15  //R Clear ADC high data register 0x00
#define TCS_RDATA 	0x16  //R Red ADC low data register 0x00
#define TCS_RDATAH 	0x17  //R Red ADC high data register 0x00
#define TCS_GDATA 	0x18  //R Green ADC low data register 0x00
#define TCS_GDATAH 	0x19  //R Green ADC high data register 0x00
#define TCS_BDATA 	0x1A  //R Blue ADC low data register 0x00
#define TCS_BDATAH 	0x1B  //R Blue ADC high data register 0x00
#define TCS_PDATA 	0x1C  //R Proximity ADC low data register 0x00
#define TCS_PDATAH 	0x1D  //R Proximity ADC high data register 0x00

#endif	/* TCS3771_H */

